<?php

namespace STM\Team\Member;

use STM\StmFactory;

/**
 * Test class for TeamMemberValidator.
 * Generated by PHPUnit on 2012-03-30 at 16:47:23.
 * @group team_member
 */
class TeamMemberValidatorTest extends \PHPUnit_Framework_TestCase {

    private $team;
    private $team_members;

    protected function setUp() {
        $this->team = StmFactory::find()->Team->findById(2);
        $this->team_members = $this->team ? StmFactory::find()->TeamMember->findByTeam($this->team) : array();
        TeamMemberValidator::init();
    }

    public function testCheck_create() {
        foreach ($this->team_members as $member) {
            $team = StmFactory::find()->Team->findById($member->getIdTeam());
            $person = StmFactory::find()->Person->findById($member->getIdPerson());
            $position = StmFactory::find()->PersonPosition->findById($member->getIdPosition());
            // existing team member can be created again
            parent::assertTrue(TeamMemberValidator::checkCreate(array('team' => $team, 'position' => $position, 'person' => $person, 'date_since' => '', 'date_to' => '', 'is_player' => false, 'dress_number' => '')));
            // invalid arguments
            $this->assert_bad_arguments('checkCreate', array('team' => $team, 'position' => $position, 'person' => null, 'date_since' => '', 'date_to' => ''));
            $this->assert_bad_arguments('checkCreate', array('team' => $team, 'position' => null, 'person' => $person, 'date_since' => '', 'date_to' => ''));
            $this->assert_bad_arguments('checkCreate', array('team' => null, 'position' => $position, 'person' => $person, 'date_since' => '', 'date_to' => ''));
            $this->assert_bad_arguments('checkCreate', array('team' => $team, 'position' => $position, 'person' => $person, 'date_since' => 'Hello', 'date_to' => 'World'));
        }
        $this->assert_bad_arguments('checkCreate', null);
    }

    public function testCheck_dress_number() {
        // dress number must be empty or number from 1 to 255
        parent::assertTrue(TeamMemberValidator::checkDressNumber(''));
        parent::assertTrue(TeamMemberValidator::checkDressNumber('254'));
        // invalid
        $invalid = array('256', 256, -1, null, array());
        foreach ($invalid as $value) {
            $this->assert_bad_arguments('checkDressNumber', $value);
        }
    }

    public function testCheck_update() {
        foreach ($this->team_members as $member) {
            // compared object must be set
            $this->assert_bad_arguments('checkUpdate', array());
            TeamMemberValidator::setTeamMember($member);
            $this->assert_bad_arguments('checkUpdate', null);
            $this->assert_bad_arguments('checkUpdate', array('position', 'date_since', 'date_to'));
            $this->assert_bad_arguments('checkUpdate', array('position' => 2, 'date_since' => '', 'date_to' => '', 'fourth'));
            TeamMemberValidator::resetTeamMember();
        }
    }

    private function assert_bad_arguments($method, $data) {
        TeamMemberValidator::init();
        parent::assertFalse(TeamMemberValidator::$method($data));
        TeamMemberValidator::init();
    }

}

?>